#!/usr/bin/perl

######################################
# Soldat Server Statistics Generator #
# Version 0.14                       #
# (c) 2003 CREEQ                     #
######################################

use File::Copy;

### CONFIG ################################################################################################################

$version = "0.14";

### FUNCTIONS #############################################################################################################

sub loadconfig {
  if (defined $ARGV[0]) { $configfile = $ARGV[0]; } else { $configfile = 'sssg.conf'; }
  %config = ();
  open(CONFIG, $configfile) or die('ERROR: Cannot open config file.');
  @file = <CONFIG>;
  close(CONFIG);
  foreach $line (@file) {
    chomp($line);
    if ((length($line) != 0) && (substr($line, 0, 1) ne "#")) {
      ($a, $b) = split(/ = /, $line);
      $config{$a} = $b;
    }
  }
}

sub loadlanguage {
  @lang = ();
  open(LANGUAGE, "language/$config{Language}") or die('ERROR: Cannot open language file.');
  @file = <LANGUAGE>;
  close(LANGUAGE);
  foreach $line (@file) {
    chomp($line);
    if ((length($line) != 0) && (substr($line, 0, 1) ne "#")) {
      if (index($line, ':') != -1) {
        $a = substr($line, 0, index($line, ':'));
        $b = substr($line, index($line, ':')+1, length($line)-index($line, ':')-1);
        $lang[$a] = $b;
      }
    }
  }
  @months = split(',', $lang[11]);
}

sub loadstyle {
  %lang = ();
  open(STYLE, "style/$config{Style}/style.conf") or die('ERROR: Cannot open stlye.');
  @file = <STYLE>;
  close(STYLE);
  foreach $line (@file) {
    chomp($line);
    if ((length($line) != 0) && (substr($line, 0, 1) ne "#")) {
      ($a, $b) = split(/ = /, $line);
      $style{$a} = $b;
    }
  }
}

sub splitdate {
  @tmp = ();
  $seperator = substr($config{DateFormat}, 1, 1);
  $pos = index($config{DateFormat}, 'D');
  if ($pos == 0) { $tmp[0] = substr($_[0], 0, index($_[0], $seperator)); } 
  elsif ($pos == 2) { $tmp[0] = substr($_[0], index($_[0], $seperator)+1, rindex($_[0], $seperator)-index($_[0], $seperator)-1); }
  elsif ($pos == 4) { $tmp[0] = substr($_[0], rindex($_[0], $seperator)+1, length($_[0])-rindex($_[0], $seperator)-1); }
  $pos = index($config{DateFormat}, 'M');
  if ($pos == 0) { $tmp[1] = substr($_[0], 0, index($_[0], $seperator)); } 
  elsif ($pos == 2) { $tmp[1] = substr($_[0], index($_[0], $seperator)+1, rindex($_[0], $seperator)-index($_[0], $seperator)-1); }
  elsif ($pos == 4) { $tmp[1] = substr($_[0], rindex($_[0], $seperator)+1, length($_[0])-rindex($_[0], $seperator)-1); }
  $pos = index($config{DateFormat}, 'Y');
  if ($pos == 0) { $tmp[2] = substr($_[0], 0, index($_[0], $seperator)); } 
  elsif ($pos == 2) { $tmp[2] = substr($_[0], index($_[0], $seperator)+1, rindex($_[0], $seperator)-index($_[0], $seperator)-1); }
  elsif ($pos == 4) { $tmp[2] = substr($_[0], rindex($_[0], $seperator)+1, length($_[0])-rindex($_[0], $seperator)-1); }
  return(@tmp);
}

sub cmpdate {
  # 0 -> date1 is erlier than date2
  # 1 -> date1 is equal as date2
  # 2 -> date1 is later than date2
  ($d1, $m1, $y1) = &splitdate($_[0]);
  ($d2, $m2, $y2) = &splitdate($_[1]);
  if ($y1 < $y2) { return(0); } else { if ($y1 > $y2) { return(2); } else {
    if ($m1 < $m2) { return(0); } else { if ($m1 > $m2) { return(2); } else {
      if ($d1 < $d2) { return(0); } else { if ($d1 > $d2) { return(2); } else { return(1); } } } }
    }
  }
}

sub getdate {
  $seperator = substr($config{DateFormat}, 1, 1);
  $a = index($_[0], '-');
  $b = $a;
  $b = index($_[0], $seperator, $b+1);
  $b = index($_[0], $seperator, $b+1);
  $b = index($_[0], '-', $b+1);
  if ($b == -1) { $b = rindex($_[0], '.'); }
  $tmp = substr($_[0], $a+1, $b-$a-1);
  return($tmp);
}

sub getfilename {
  $a = rindex($_[0], '/');
  $tmp = substr($_[0], $a+1, length($_[0])-$a-1);
  return($tmp);
}

sub cmpext {
  # extended datecheck
  # 0 -> date1 is erlier than date2
  # 1 -> date1 is equal as date2
  # 2 -> date1 is later than date2
  $tmp = &getdate($_[0]);
  $date1 = substr($_[0], index($_[0], $tmp)+length($tmp)+1, rindex($_[0], '.')-index($_[0], $tmp)-length($tmp)-1);
  $tmp = &getdate($_[1]);
  $date2 = substr($_[1], index($_[1], $tmp)+length($tmp)+1, rindex($_[1], '.')-index($_[1], $tmp)-length($tmp)-1);
  if ($date1 eq 'tx') { $date1 = 0; } 
  if ($date2 eq 'tx') { $date2 = 0; } 
  if ($date1 == $date2) { return(1); }
  if ($date1 < $date2) { return(0); }
  if ($date1 > $date2) { return(2); }        
}

sub readfastmode {
  @oldlogs = ();
  @newlogs = ();
  %fastmode = ();

  open(FAST, 'fastmode.tmp');
  while (<FAST>) {
    chomp($_);
    if ((length($_) != 0) && (substr($_, 0, 1) ne "#")) {
      ($a, $b) = split(/ = /, $_);
      if ($a eq 'done') { push(@oldlogs, $b); }
        else {
          if ($a eq 'Month') {
            ($month, $count) = split(/:/, $b);
            $playmonths[$month] = $count;
          } else {
            if ($a eq 'Hour') {
              ($hour, $count) = split(/:/, $b);
              $playhours[$hour] = $count;
            } else {
              if ($a eq 'Player') {
                ($player, $id, $skill, $kills, $deaths, $suicides, @weaps) = split("\":\"", $b);
                $players->{$player}->{id} = $id;
                $players->{$player}->{skill} = $skill;
                $players->{$player}->{kills} = $kills;
                $players->{$player}->{deaths} = $deaths;
                $players->{$player}->{suicides} = $suicides;
		$players->{$player}->{captures} = 0;
		$players->{$player}->{returnes} = 0;
                for ($i=0;$i<=$#weapons;$i++) {
                  if ($weaps[$i] != 0) { $players->{$player}->{killweapon}->{$weapons[$i]} = $weaps[$i]; }
                }
                for ($i=($#weapons+1);$i<=($#weapons*2+1);$i++) {
                  if ($weaps[$i] != 0) { $players->{$player}->{deathweapon}->{$weapons[$i-$#weapons-1]} = $weaps[$i]; }
                }
              } else { 
                if ($a eq 'Weapon') {
                  ($weapon, $id, $count) = split("\":\"", $b);
                  $weapons->{$weapon}->{id} = $id;
                  $weapons->{$weapon}->{kills} = $count;
                } else { $fastmode{$a} = $b; }
            }
          }
        }
      }
    }
  }
  close(FAST);

  foreach $log (@logs) {
    $found = 0;
    foreach $oldlog (@oldlogs) {
      if ($log eq $oldlog) { $found = 1; last; }
    }
    if ($found == 0) { push(@newlogs, $log); }
  }

  $begindate = $fastmode{BeginDate};
  $enddate = $fastmode{EndDate};
  $TotalKills = $fastmode{TotalKills};
  $TotalSuicides = $fastmode{TotalSuicides};
}

sub writefastmode {
  push(@logs, @oldlogs);
  open(FAST, '>fastmode.tmp');
  print FAST "######################################################\n";
  print FAST "# Soldat Server Statistics Generator - FastMode File #\n";
  print FAST "# For SSSG Version $version" . ' ' x (34-length($version)) . "#\n";
  print FAST "# (c) 2003 CREEQ                                     #\n";
  print FAST "######################################################\n\n";
  print FAST "# DO NOT MODIFY THIS FILE !!!\n\n";
  foreach $log (@logs) {
    print FAST "done = $log\n";
  }
  print FAST "\n";
  print FAST "BeginDate = $begindate\n";
  print FAST "EndDate = $enddate\n";
  print FAST "TotalKills = $TotalKills\n";
  print FAST "TotalSuicides = $TotalSuicides\n\n";
  for ($i=1;$i<=12;$i++) {
    if (defined $playmonths[$i]) { print FAST "Month = $i:$playmonths[$i]\n"; }
  }
  print FAST "\n";
  for ($i=0;$i<24;$i++) {
    if (defined $playhours[$i]) { print FAST "Hour = $i:$playhours[$i]\n"; }
  }
  print FAST "\n";
  foreach $player (keys %{$players}) {
    print FAST "Player = $player\":\"" . $players->{$player}->{id} . "\":\"";
    print FAST $players->{$player}->{skill} . "\":\"";
    print FAST $players->{$player}->{kills} . "\":\"";
    print FAST $players->{$player}->{deaths} . "\":\"";
    print FAST $players->{$player}->{suicides} . "\":\"";
    for ($i=0;$i<=$#weapons;$i++) {
      if (defined $players->{$player}->{killweapon}->{$weapons[$i]}) { print FAST $players->{$player}->{killweapon}->{$weapons[$i]}; } else { print FAST '0'; }
      print FAST "\":\"";
    }
    for ($i=0;$i<=$#weapons;$i++) {
      if (defined $players->{$player}->{deathweapon}->{$weapons[$i]}) { print FAST $players->{$player}->{deathweapon}->{$weapons[$i]}; } else { print FAST '0'; }
      print FAST "\":\"";
    }
    print FAST "\n";
  }
  print FAST "\n";
  foreach $weapon (keys %{$weapons}) {
    print FAST "Weapon = $weapon\":\"" . $weapons->{$weapon}->{id} . "\":\"";
    print FAST $weapons->{$weapon}->{kills} . "\n";
  }
  close(FAST);
}

sub generatestat {
  @logs = `find $config{LogDir} -name ?ill?og*.txt`;
  for ($i=0;$i<=$#logs;$i++) { chomp($logs[$i]); }
  $consolelog = `find $config{LogDir} -name ?onsole?og.txt`;
  chomp($consolelog);
  if ($consolelog ne '') {
    open(LOG, $consolelog);
    @consolelog = <LOG>;
    close(LOG);
  }

  if ($config{FastMode} eq 'yes') {
    foreach $log (@logs) {
      if (defined $lastdate) {
        if (&cmpdate(&getdate(&getfilename($lastdate)), &getdate(&getfilename($log))) == 0) { $lastdate = $log; }
        if (&cmpdate(&getdate(&getfilename($lastdate)), &getdate(&getfilename($log))) == 1) {
          if (&cmpext(&getfilename($lastdate), &getfilename($log)) == 0) { $lastdate = $log; }
        }
      }  else { $lastdate = $log; }
    }
    for ($i=0;$i<=$#logs;$i++) {
      if ($logs[$i] eq $lastdate) { splice(@logs, $i, 1); last; }
    }
  }

  if (($config{FastMode} eq 'yes') && (-e 'fastmode.tmp')) {
    &readfastmode;
    $lastplayerid = (keys %{$players}) + 2;
    $lastweaponid = (keys %{$weapons}) + 2;
  } else {
    @newlogs = @logs;
    @killlog = ();
    $TotalSuicides = 0;
    $TotalKills = 0;
    $lastplayerid = 1;
    $lastweaponid = 1;
  }

  foreach $log (@newlogs) {
    open(LOG, $log);
    push(@killlog, <LOG>);
    close(LOG);
  }
  if ($#killlog != -1) {
    &makestats;
    if ($config{FastMode} eq 'yes') { &writefastmode; }
  }

  if ($config{FastMode} eq 'yes') {
    @killlog = ();
    open(LOG, $lastdate);
    push(@killlog, <LOG>);
    close(LOG);
    &makestats;
  }
  
  &makeconsolestats;

  $TotalPlayers = keys %{$players};

  ### RANK ###
  @order = sort { $players->{$b}->{skill} <=> $players->{$a}->{skill} } keys %{$players};
  for ($i=0;$i<=$#order;$i++) {
    $players->{$order[$i]}->{rank} = ($i+1);
  }

  ### WEAPONS ###
  foreach $weapon (keys %{$weapons}) {
    for ($i=0;$i<=$#weapons;$i++) {
      if ($weapons[$i] eq $weapon) { $weapons->{$weapon}->{id} = ($i+1); last; }
    }
  }

  ### AWARDS ###
  &initawards;
  foreach $player (keys %{$players}) {
    if ($players->{$player}->{deaths} != 0) { $players->{$player}->{killdeath} = sprintf("%0.2f", ($players->{$player}->{kills}/$players->{$player}->{deaths})); }
      else { $players->{$player}->{killdeath} = sprintf("%0.2f", $players->{$player}->{kills}); }
    if ($players->{$player}->{killdeath} > $awards->{killdeath}->{value}) {
      $awards->{killdeath}->{value} = $players->{$player}->{killdeath};
      $awards->{killdeath}->{winner} = $player;
    }
    if ($players->{$player}->{captures} > $awards->{flagcapture}->{value}) {
      $awards->{flagcapture}->{value} = $players->{$player}->{captures};
      $awards->{flagcapture}->{winner} = $player;
    }
    if ($players->{$player}->{returnes} > $awards->{flagreturn}->{value}) {
      $awards->{flagreturn}->{value} = $players->{$player}->{returnes};
      $awards->{flagreturn}->{winner} = $player;
    }
  }
  foreach $award (keys %{$awards}) {
    if ($awards->{$award}->{value} > 0) {
      $players->{$awards->{$award}->{winner}}->{skill} += $awards->{$award}->{skill};
    }
  }
}

sub initawards {
  $awards->{killdeath}->{value} = 0;
  $awards->{killdeath}->{language} = 42;
  $awards->{killdeath}->{skill} = 10;
  $awards->{flagcapture}->{value} = 0;
  $awards->{flagcapture}->{language} = 43;
  $awards->{flagcapture}->{skill} = 10;
  $awards->{flagreturn}->{value} = 0;
  $awards->{flagreturn}->{language} = 44;
  $awards->{flagreturn}->{skill} = 10;
  return(0);
}

sub initplayer {
  $players->{$_[0]}->{kills} = 0;
  $players->{$_[0]}->{deaths} = 0;
  $players->{$_[0]}->{suicides} = 0;
  $players->{$_[0]}->{id} = $lastplayerid++;
  $players->{$_[0]}->{skill} = 1000;
  $players->{$_[0]}->{captures} = 0;
  $players->{$_[0]}->{returnes} = 0;
  return(0);
}

sub initweapon {
  $weapons->{$_[0]}->{kills} = 0;
  $weapons->{$_[0]}->{id} = $lastweaponid++;
  return(0);
}

sub initmap {
  $maps->{$_[0]}->{played} = 0;
  return(0);
}

sub makeconsolestats {
  foreach $line (@consolelog) {
    while ((substr($line, length($line)-1, 1) eq "\n") || (substr($line, length($line)-1, 1) eq "\r")) { chop($line); }
    if (index($line, 'scores for') != -1) {
      $player = substr($line, 0, index($line, 'scores for')-1);
      if (!defined $players->{$player}) { &initplayer($player); }
      $players->{$player}->{captures} += 1;
      $players->{$player}->{skill} += 5;
    }    
    if (index($line, 'returned the') != -1) {
      $player = substr($line, 0, index($line, 'returned the')-1);
      if (!defined $players->{$player}) { &initplayer($player); }
      $players->{$player}->{returnes} += 1;
      $players->{$player}->{skill} += 5;
    }    
    if (index($line, 'Next map:') != -1) {
      $map = substr($line, rindex($line, ':')+2, length($line)-index($line, 'Next map:')-1);
      if (!defined $maps->{$map}) { &initmap($map); }
      $maps->{$map}->{played} += 1;
    }    
    if (substr($line, 0, 1) eq '[') {
      $player = substr($line, 1, index($line, ']')-1);
      $message = substr($line, index($line, ']')+2, length($line)-index($line, ']')-2);
      if (!defined $players->{$player}) { &initplayer($player); }
      push(@{$players->{$player}->{chat}}, $message);
    }
  }
}

sub makestats {
  if (defined $config{IgnoreUsers}) { @ignores = (split(/;/, $config{IgnoreUsers}), ''); }
  foreach $line (@killlog) {
    while ((substr($line, length($line)-1, 1) eq "\n") || (substr($line, length($line)-1, 1) eq "\r")) { chop($line); }
    if ((substr($line, 0, 1) ne " ") && (length($line) > 0)) {
      $date = substr($line, 0, index($line, ' '));
      $time = substr($line, length($date)+1, index($line, ' ', length($date)+1)-length($date)-1);
      $killer = substr($line, length($date.$time)+2, index($line, '/', length($date))-length($date.$time)-3);
      if ((substr($killer, 0, 4) eq 'a.m.') || (substr($killer, 0, 4) eq 'p.m.')) { substr($killer, 0, 5) = ''; }
      if ((substr($killer, 0, 2) eq 'AM') || (substr($killer, 0, 2) eq 'PM')) { substr($killer, 0, 3) = ''; }
      $weapon = substr($line, rindex($line, '/')+2, length($line)-rindex($line, '/')-1);
      if ($weapon ne 'himself') { $victim = substr($line, index($line, '/', length($date))+2, rindex($line, '/')-index($line, '/', length($date))-3); }
      foreach (@ignores) {
        if ((lc $killer eq lc $_) || (lc $victim eq lc $_)) { $line = ''; last; }
      }
      if ($line eq '') { next; }

      if (defined $begindate) { if (&cmpdate($begindate, $date) == 2) { $begindate = $date; } } else { $begindate = $date; }
      if (defined $enddate) { if (&cmpdate($enddate, $date) == 0) { $enddate = $date; } } else { $enddate = $date; }
      $hour = substr($time, 0, index($time, ':'));
      ($day, $month, $year) = &splitdate($date);
      if (defined $playhours[$hour]) { $playhours[$hour] += 1; } else { $playhours[$hour] = 1; }
      if (defined $playmonths[$month]) { $playmonths[$month] += 1; } else { $playmonths[$month] = 1; }
      if ($weapon eq 'himself') { $TotalSuicides += 1; }
      $TotalKills += 1;
      if (!defined $players->{$killer}) { &initplayer($killer); }
      if (!defined $players->{$victim}) { &initplayer($victim); }
      if (($weapon ne 'himself') && ($weapon ne '')) {
        if (!defined $weapons->{$weapon}) { &initweapon($weapon); }
        $players->{$killer}->{kills} += 1;
        $players->{$victim}->{deaths} += 1;
        $players->{$killer}->{skill} += sprintf("%d", ($players->{$victim}->{skill} / $players->{$killer}->{skill} * 10));
        $weapons->{$weapon}->{kills} += 1;
       	if ($players->{$victim}->{skill} < 2000) { $players->{$victim}->{skill} -= 10; }
          else { $players->{$victim}->{skill} -= sprintf("%d", ($players->{$victim}->{skill} / $players->{$killer}->{skill} * 10)); }
        if (defined $players->{$killer}->{killweapon}->{$weapon}) { $players->{$killer}->{killweapon}->{$weapon} += 1; } else { $players->{$killer}->{killweapon}->{$weapon} = 1; }
        if (defined $players->{$victim}->{deathweapon}->{$weapon}) { $players->{$victim}->{deathweapon}->{$weapon} += 1; } else { $players->{$victim}->{deathweapon}->{$weapon} = 1; }
      } else {
        $players->{$killer}->{deaths} += 1;
        $players->{$killer}->{suicides} += 1;
   	$players->{$killer}->{skill} -= 3;
      }
    }
  }
}

### MAIN ##################################################################################################################

$playerdetails = ();
$weapondetails = ();
@weapons = ('Barret M82A1', 'Grenade', 'M79', 'Desert Eagles', 'Steyr AUG', 'Ak-74', 'Spas-12', 'XM214 Minigun', 'USSOCOM', 'HK MP5', 'FN Minimi', 'Ruger 77', 'Clusters', 'Hands', 'Bow', 'Flame Bow', 'Flamer', 'Chainsaw', 'Combat Knife', 'LAW', 'Stationary Gun');
$begin = time;
&loadconfig;
&loadlanguage;
&loadstyle;
&generatestat;
mkdir $config{StatDir}, 0755;
unlink "$config{StatDir}*";
copy("style/$config{Style}/vbar.jpg", $config{StatDir});
open(INDEX, ">$config{StatDir}index.html") or die("ERROR: Cannot write stat file.");

### HEAD ###
print INDEX "<html>\n";
print INDEX "<head>\n";
print INDEX "<title>$config{ServerName} - Soldat Server $lang[0]</title>\n";
print INDEX "</head>\n";
print INDEX "<body bgcolor=\"$style{BGColor}\" text=\"$style{TextColor}\" link=\"$style{LinkColor}\">\n";
print INDEX "<center>\n";
print INDEX "<font face=\"$style{FontFace}\" size=\"5\"><b><u>$config{ServerName}</u></b></font><br>\n";
print INDEX "<font face=\"$style{FontFace}\" size=\"2\"><b>$lang[1] <a href=\"mailto:$config{YourMail}\">$config{YourName}</a></b></font><br><br>\n";
print INDEX "<font face=\"$style{FontFace}\" size=\"2\">$lang[2] " . localtime($begin) . ".</font><br><br>\n";

## GENERAL INFO ###
if ($config{ShowGeneralInfo} eq 'yes') {
  print INDEX "<table width=\"90%\" border=\"$style{TableBorder}\" cellspacing=\"1\">\n";
  print INDEX "<tr><td bgcolor=\"$style{TableTopicColor}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[3]</b></font></td></tr>\n";
  print INDEX "</table>\n";
  print INDEX "<table width=\80%\" border=\"$style{TableBorder}\" cellspacing=\"0\">\n";
  print INDEX "<tr>\n";
  print INDEX "<td width=\"33%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[4]</b></font></td>\n";
  print INDEX "<td width=\"67%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$config{ServerName}</b></font></td>\n";
  print INDEX "</tr>\n";
  print INDEX "<tr>\n";
  print INDEX "<td width=\"33%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[5]</b></font></td>\n";
  print INDEX "<td width=\"67%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$config{ServerIP} @ $config{ServerPort}</b></font></td>\n";
  print INDEX "</tr>\n";
  print INDEX "<tr>\n";
  print INDEX "<td width=\"33%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[6]</b></font></td>\n";
  print INDEX "<td width=\"67%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$begindate - $enddate</b></font></td>\n";
  print INDEX "</tr>\n";
  print INDEX "<tr>\n";
  print INDEX "<td width=\"33%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[7]</b></font></td>\n";
  print INDEX "<td width=\"67%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$TotalPlayers</b></font></td>\n";
  print INDEX "</tr>\n";
  print INDEX "<tr>\n";
  print INDEX "<td width=\"33%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[8]</b></font></td>\n";
  print INDEX "<td width=\"67%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$TotalKills</b></font></td>\n";
  print INDEX "</tr>\n";
  print INDEX "<tr>\n";
  print INDEX "<td width=\"33%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[9]</b></font></td>\n";
  print INDEX "<td width=\"67%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$TotalSuicides</b></font></td>\n";
  print INDEX "</tr>\n";
  print INDEX "</table>\n";
  print INDEX "<br><br>\n";
}

### KILLS BY MONTH ###
if ($config{ShowKillsByMonth} eq 'yes') {
  print INDEX "<table width=\"90%\" border=\"$style{TableBorder}\" cellspacing=\"1\">\n";
  print INDEX "<tr><td bgcolor=\"$style{TableTopicColor}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[10]</b></font></td></tr>\n";
  print INDEX "</table>\n";
  print INDEX "<table width=\80%\" border=\"$style{TableBorder}\" cellspacing=\"0\">\n";
  print INDEX "<tr>\n";
  $maxmonth = 0;
  for ($month=1;$month<=12;$month++) {
    if (!defined $playmonths[$month]) { $playmonths[$month] = 0; }
    if ($playmonths[$month] > $maxmonth) { $maxmonth = $playmonths[$month]; }
  }
  for ($month=1;$month<=12;$month++) {
    print INDEX "<td width=\"8%\" bgcolor=\"$style{TableColor2}\" align=\"center\" valign=\"bottom\"><font color=\"$style{TableTopicTextColor}\" size=\"1\"><br>" . sprintf("%0.0f", $playmonths[$month]/$TotalKills*100) . "%<br><img src=\"vbar.jpg\" width=\"15\" height=\"" . ($playmonths[$month]/$maxmonth*100)  . "\"></b></font></td>\n";
  }
  print INDEX "</tr><tr>\n";
  for ($month=1;$month<=12;$month++) {
    print INDEX "<td width=\"8%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"2\"><b>$months[$month-1]</b></font></td>\n";
  }
  print INDEX "</tr>\n";
  print INDEX "</table>\n";
  print INDEX "<br><br>\n";
}

### KILLS BY HOUR ###
if ($config{ShowKillsByHour} eq 'yes') {
  print INDEX "<table width=\"90%\" border=\"$style{TableBorder}\" cellspacing=\"1\">\n";
  print INDEX "<tr><td bgcolor=\"$style{TableTopicColor}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[12]</b></font></td></tr>\n";
  print INDEX "</table>\n";
  print INDEX "<table width=\80%\" border=\"$style{TableBorder}\" cellspacing=\"0\">\n";
  print INDEX "<tr>\n";
  $maxhour = 0;
  for ($hour=0;$hour<24;$hour++) {
    if (!defined $playhours[$hour]) { $playhours[$hour] = 0; }
    if ($playhours[$hour] > $maxhour) { $maxhour = $playhours[$hour]; }
  }
  for ($hour=0;$hour<24;$hour++) {
    print INDEX "<td width=\"4%\" bgcolor=\"$style{TableColor2}\" align=\"center\" valign=\"bottom\"><font color=\"$style{TableTopicTextColor}\" size=\"1\"><br>" . sprintf("%0.0f", $playhours[$hour]/$TotalKills*100) . "%<br><img src=\"vbar.jpg\" width=\"15\" height=\"" . ($playhours[$hour]/$maxhour*100)  . "\"></b></font></td>\n";
  }
  print INDEX "</tr><tr>\n";
  for ($hour=0;$hour<24;$hour++) {
    print INDEX "<td width=\"4%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"2\"><b>$hour</b></font></td>\n";
  }
  print INDEX "</tr>\n";
  print INDEX "</table>\n";
  print INDEX "<br><br>\n";
}

### TOP KILLERS ###
if ($config{ShowTopKillers} eq 'yes') {
  print INDEX "<table width=\"90%\" border=\"$style{TableBorder}\" cellspacing=\"0\">\n";
  print INDEX "<tr><td bgcolor=\"$style{TableTopicColor}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[13]</b></font></td></tr>\n";
  print INDEX "</table>\n";
  print INDEX "<table width=\80%\" border=\"$style{TableBorder}\" cellspacing=\"1\">\n";
  print INDEX "<tr>\n";
  print INDEX "<td width=\"35%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[14]</b></font></td>\n";
  print INDEX "<td width=\"10%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[29]</b></font></td>\n";
  print INDEX "<td width=\"10%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[15]</b></font></td>\n";
  print INDEX "<td width=\"10%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[16]</b></font></td>\n";
  print INDEX "<td width=\"35%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[17]</b></font></td>\n";
  print INDEX "</tr>\n";
  $count = 0;
  foreach $player (sort {$players->{$a}->{rank} <=> $players->{$b}->{rank}} keys %{$players}) {
    $playerdetails{$player} = 0;
    $max = 0;
    foreach (keys %{$players->{$player}->{killweapon}}) {
      if ($players->{$player}->{killweapon}->{$_} > $max) { $max = $players->{$player}->{killweapon}->{$_}; $favweapon = $_; }
    }
    $weapondetails{$favweapon} = 0;
    print INDEX "<tr>\n";
    print INDEX "<td width=\"35%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b><a href=\"player" . $players->{$player}->{id} . "/\">$player</a></b></font></td>\n";
    print INDEX "<td width=\"10%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>" . $players->{$player}->{skill} . "</b></font></td>\n";
    print INDEX "<td width=\"10%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$players->{$player}->{kills}</b></font></td>\n";
    print INDEX "<td width=\"10%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$players->{$player}->{killdeath}</b></font></td>\n";
    print INDEX "<td width=\"35%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$favweapon</b></font></td>\n";
    print INDEX "</tr>\n";
    if (++$count == 10) { last; }
  }
  print INDEX "</table>\n";
  print INDEX "<br><br>\n";
}

### TOP VICTIMS ###
if ($config{ShowTopVictims} eq 'yes') {
  print INDEX "<table width=\"90%\" border=\"$style{TableBorder}\" cellspacing=\"0\">\n";
  print INDEX "<tr><td bgcolor=\"$style{TableTopicColor}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[18]</b></font></td></tr>\n";
  print INDEX "</table>\n";
  print INDEX "<table width=\80%\" border=\"$style{TableBorder}\" cellspacing=\"1\">\n";
  print INDEX "<tr>\n";
  print INDEX "<td width=\"75%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[14]</b></font></td>\n";
  print INDEX "<td width=\"25%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[19]</b></font></td>\n";
  print INDEX "</tr>\n";
  $count = 0;
  foreach $player (sort {$players->{$b}->{deaths} <=> $players->{$a}->{deaths}} keys %{$players}) {
    $playerdetails{$player} = 0;
    print INDEX "<tr>\n";
    print INDEX "<td width=\"75%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b><a href=\"player" . $players->{$player}->{id} . "/\">$player</a></b></font></td>\n";
    print INDEX "<td width=\"25%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$players->{$player}->{deaths}</b></font></td>\n";
    print INDEX "</tr>\n";
    if (++$count == 10) { last; }
  }
  print INDEX "</table>\n";
  print INDEX "<br><br>\n";
}

### AWARDS ###
if ($config{ShowAwards} eq 'yes') {
  print INDEX "<table width=\"90%\" border=\"$style{TableBorder}\" cellspacing=\"0\">\n";
  print INDEX "<tr><td bgcolor=\"$style{TableTopicColor}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[40]</b></font></td></tr>\n";
  print INDEX "</table>\n";
  print INDEX "<table width=\80%\" border=\"$style{TableBorder}\" cellspacing=\"1\">\n";
  print INDEX "<tr>\n";
  print INDEX "<td width=\"70%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[41]</b></font></td>\n";
  print INDEX "<td width=\"30%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[14]</b></font></td>\n";
  print INDEX "</tr>\n";
  foreach $award (keys %{$awards}) {
    if ($awards->{$award}->{value} == 0) { next; }
    $playerdetails{$awards->{$award}->{winner}} = 0;
    print INDEX "<tr>\n";
    print INDEX "<td width=\"70%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[$awards->{$award}->{language}] ($awards->{$award}->{value})</b></font></td>\n";
    print INDEX "<td width=\"30%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b><a href=\"player" . $players->{$awards->{$award}->{winner}}->{id} . "/\">$awards->{$award}->{winner}</a></b></font></td>\n";
    print INDEX "</tr>\n";
  }
  print INDEX "</table>\n";
  print INDEX "<br><br>\n";
}

### USED WEAPONS ###
if ($config{ShowUsedWeapons} eq 'yes') {
  print INDEX "<table width=\"90%\" border=\"$style{TableBorder}\" cellspacing=\"0\">\n";
  print INDEX "<tr><td bgcolor=\"$style{TableTopicColor}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[20]</b></font></td></tr>\n";
  print INDEX "</table>\n";
  print INDEX "<table width=\80%\" border=\"$style{TableBorder}\" cellspacing=\"1\">\n";
  print INDEX "<tr>\n";
  print INDEX "<td width=\"75%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[21]</b></font></td>\n";
  print INDEX "<td width=\"25%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[15]</b></font></td>\n";
  print INDEX "</tr>\n";
  foreach $weapon (sort {$weapons->{$b}->{kills} <=> $weapons->{$a}->{kills}} keys %{$weapons}) {
    $weapondetails{$weapon} = 0;
    print INDEX "<tr>\n";
    print INDEX "<td width=\"75%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b><a href=\"weapon" . $weapons->{$weapon}->{id} . "\">$weapon</a></b></font></td>\n";
    print INDEX "<td width=\"25%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>" . $weapons->{$weapon}->{kills} . "</b></font></td>\n";
    print INDEX "</tr>\n";
  }
  print INDEX "</table>\n";
  print INDEX "<br><br>\n";
}

### CAPTURE THE FLAG ###
if ($config{ShowCaptureTheFlag} eq 'yes') {
  print INDEX "<table width=\"90%\" border=\"$style{TableBorder}\" cellspacing=\"0\">\n";
  print INDEX "<tr><td bgcolor=\"$style{TableTopicColor}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[31]</b></font></td></tr>\n";
  print INDEX "</table>\n";
  print INDEX "<table width=\80%\" border=\"$style{TableBorder}\" cellspacing=\"1\">\n";
  print INDEX "<tr>\n";
  print INDEX "<td width=\"50%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[14]</b></font></td>\n";
  print INDEX "<td width=\"25%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[32]</b></font></td>\n";
  print INDEX "<td width=\"25%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[33]</b></font></td>\n";
  print INDEX "</tr>\n";
  $count = 0;
  foreach $player (sort {$players->{$b}->{captures} <=> $players->{$a}->{captures}} keys %{$players}) {
    $playerdetails{$player} = 0;
    print INDEX "<tr>\n";
    print INDEX "<td width=\"50%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b><a href=\"player" . $players->{$player}->{id} . "/\">$player</a></b></font></td>\n";
    print INDEX "<td width=\"25%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>" . $players->{$player}->{captures} . "</b></font></td>\n";
    print INDEX "<td width=\"25%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>" . $players->{$player}->{returnes} . "</b></font></td>\n";
    print INDEX "</tr>\n";
    if (++$count == 5) { last; }
  }
  print INDEX "</table>\n";
  print INDEX "<br><br>\n";
}

### PLAYED MAPS ###
if ($config{ShowPlayedMaps} eq 'yes') {
  print INDEX "<table width=\"90%\" border=\"$style{TableBorder}\" cellspacing=\"0\">\n";
  print INDEX "<tr><td bgcolor=\"$style{TableTopicColor}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[34]</b></font></td></tr>\n";
  print INDEX "</table>\n";
  print INDEX "<table width=\80%\" border=\"$style{TableBorder}\" cellspacing=\"1\">\n";
  print INDEX "<tr>\n";
  print INDEX "<td width=\"75%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[35]</b></font></td>\n";
  print INDEX "<td width=\"25%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[36]</b></font></td>\n";
  print INDEX "</tr>\n";
  $count = 0;
  foreach $map (sort {$maps->{$b}->{played} <=> $maps->{$a}->{played}} keys %{$maps}) {
    print INDEX "<tr>\n";
    print INDEX "<td width=\"75%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$map</b></font></td>\n";
    print INDEX "<td width=\"25%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>" . $maps->{$map}->{played} . "</b></font></td>\n";
    print INDEX "</tr>\n";
    if (++$count == 5) { last; }
  }
  print INDEX "</table>\n";
  print INDEX "<br><br>\n";
}

### TOP CHATTERS ###
if ($config{ShowTopChatters} eq 'yes') {
  print INDEX "<table width=\"90%\" border=\"$style{TableBorder}\" cellspacing=\"0\">\n";
  print INDEX "<tr><td bgcolor=\"$style{TableTopicColor}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[37]</b></font></td></tr>\n";
  print INDEX "</table>\n";
  print INDEX "<table width=\80%\" border=\"$style{TableBorder}\" cellspacing=\"1\">\n";
  print INDEX "<tr>\n";
  print INDEX "<td width=\"35%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[14]</b></font></td>\n";
  print INDEX "<td width=\"15%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[38]</b></font></td>\n";
  print INDEX "<td width=\"50%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[39]</b></font></td>\n";
  print INDEX "</tr>\n";
  $count = 0;
  foreach $player (sort {$#{$players->{$b}->{chat}} <=> $#{$players->{$a}->{chat}}} keys %{$players}) {
    $playerdetails{$player} = 0;
    print INDEX "<tr>\n";
    print INDEX "<td width=\"35%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b><a href=\"player" . $players->{$player}->{id} . "/\">$player</a></b></font></td>\n";
    print INDEX "<td width=\"15%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>" . ($#{$players->{$player}->{chat}}+1) . "</b></font></td>\n";
    print INDEX "<td width=\"50%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>" . ${$players->{$player}->{chat}}[int(rand($#{$players->{$player}->{chat}}))] . "</b></font></td>\n";
    print INDEX "</tr>\n";
    if (++$count == 10) { last; }
  }
  print INDEX "</table>\n";
  print INDEX "<br><br>\n";
}

### FOOT ###
$gentime = time-$begin;
$hours = int ($gentime / 3600);
$gentime -= $hours * 3600;
$minutes = int ($gentime / 60);
$gentime -= $minutes * 60;
$seconds = $gentime;
$gentime = '';
if ($hours > 0) { $gentime = "$hours $lang[22] "; }
if ($minutes > 0) { $gentime = $gentime . "$minutes $lang[24] "; }
$gentime = $gentime . "$seconds $lang[25]";
print INDEX "<font face=\"$style{FontFace}\" size=\"1\"><b>\n";
print INDEX "<a href=\"http://fool.homelinux.org/sssg/\" target=\"_blank\">Soldat Server Statistics Generator</a> - Version $version - &copy 2003 <a href=\"mailto:creeq\@web.de?subject=solstat\">CREEQ</a><br>\n";

### GENERATE WEAPON DETAILS ###
foreach $weapon (keys %weapondetails) {
  mkdir $config{StatDir} . "weapon" . $weapons->{$weapon}->{id}, 0755;
  open(DETAIL, ">" . $config{StatDir} . "weapon" . $weapons->{$weapon}->{id} . "/index.html") or die("ERROR: Cannot write stat file ($player).");
  print DETAIL "<html>\n";
  print DETAIL "<head>\n";
  print DETAIL "<title>$config{ServerName} - Soldat Server $lang[0] - $player</title>\n";
  print DETAIL "</head>\n";
  print DETAIL "<body bgcolor=\"$style{BGColor}\" text=\"$style{TextColor}\" link=\"$style{LinkColor}\">\n";
  print DETAIL "<center>\n";
  print DETAIL "<font face=\"$style{FontFace}\" size=\"5\"><b><u>$config{ServerName}</u></b></font><br>\n";
  print DETAIL "<font face=\"$style{FontFace}\" size=\"2\"><b><a href=\"..\">$lang[26]</a></b></font><br><br>\n";
  print DETAIL "<font face=\"$style{FontFace}\" size=\"3\"><b>$lang[21]: $weapon</b></font><br><br>\n";

  ## GENERAL INFO ###
  print DETAIL "<table width=\"90%\" border=\"$style{TableBorder}\" cellspacing=\"1\">\n";
  print DETAIL "<tr><td bgcolor=\"$style{TableTopicColor}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[27]</b></font></td></tr>\n";
  print DETAIL "</table>\n";
  print DETAIL "<table width=\80%\" border=\"$style{TableBorder}\" cellspacing=\"0\">\n";
  print DETAIL "<tr>\n";
  print DETAIL "<td width=\"50%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[8]</b></font></td>\n";
  print DETAIL "<td width=\"50%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>" . $weapons->{$weapon}->{kills} . "</b></font></td>\n";
  print DETAIL "</tr>\n";
  print DETAIL "</table>\n";
  print DETAIL "<br><br>\n";

  ### TOP KILLERS ###
  print DETAIL "<table width=\"90%\" border=\"$style{TableBorder}\" cellspacing=\"0\">\n";
  print DETAIL "<tr><td bgcolor=\"$style{TableTopicColor}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[13]</b></font></td></tr>\n";
  print DETAIL "</table>\n";
  print DETAIL "<table width=\80%\" border=\"$style{TableBorder}\" cellspacing=\"1\">\n";
  print DETAIL "<tr>\n";
  print DETAIL "<td width=\"75%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[14]</b></font></td>\n";
  print DETAIL "<td width=\"25%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[15]</b></font></td>\n";
  print DETAIL "</tr>\n";
  $count = 0;
  foreach $player (sort {$players->{$b}->{killweapon}->{$weapon} <=> $players->{$a}->{killweapon}->{$weapon}} keys %{$players}) {
    $playerdetails{$player} = 0;
    print DETAIL "<tr>\n";
    print DETAIL "<td width=\"75%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b><a href=\"../player" . $players->{$player}->{id} . "/\">$player</a></b></font></td>\n";
    print DETAIL "<td width=\"25%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>" . $players->{$player}->{killweapon}->{$weapon} . "</b></font></td>\n";
    print DETAIL "</tr>\n";
    if (++$count == 5) { last; }
  }
  print DETAIL "</table>\n";
  print DETAIL "<br><br>\n";

  ### TOP VICTIMS ###
  print DETAIL "<table width=\"90%\" border=\"$style{TableBorder}\" cellspacing=\"0\">\n";
  print DETAIL "<tr><td bgcolor=\"$style{TableTopicColor}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[18]</b></font></td></tr>\n";
  print DETAIL "</table>\n";
  print DETAIL "<table width=\80%\" border=\"$style{TableBorder}\" cellspacing=\"1\">\n";
  print DETAIL "<tr>\n";
  print DETAIL "<td width=\"75%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[14]</b></font></td>\n";
  print DETAIL "<td width=\"25%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[19]</b></font></td>\n";
  print DETAIL "</tr>\n";
  $count = 0;
  foreach $player (sort {$players->{$b}->{deathweapon}->{$weapon} <=> $players->{$a}->{deathweapon}->{$weapon}} keys %{$players}) {
    $playerdetails{$player} = 0;
    print DETAIL "<tr>\n";
    print DETAIL "<td width=\"75%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b><a href=\"../player" . $players->{$player}->{id} . "/\">$player</a></b></font></td>\n";
    print DETAIL "<td width=\"25%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>" . $players->{$player}->{deathweapon}->{$weapon} . "</b></font></td>\n";
    print DETAIL "</tr>\n";
    if (++$count == 5) { last; }
  }
  print DETAIL "</table>\n";
  print DETAIL "<br><br>\n";

  print DETAIL "<font face=\"$style{FontFace}\" size=\"2\"><b><a href=\"..\">$lang[26]</a></b></font><br><br>\n";
  print DETAIL "</center>\n";
  print DETAIL "</body>\n";
  print DETAIL "</html>\n";
  close(DETAIL);
}

### GENERATE PLAYER DETAILS ###
foreach $player (keys %playerdetails) {
  mkdir $config{StatDir} . "player" . $players->{$player}->{id}, 0755;
  open(DETAIL, ">" . $config{StatDir} . "player" . $players->{$player}->{id} . "/index.html") or die("ERROR: Cannot write stat file ($player).");
  print DETAIL "<html>\n";
  print DETAIL "<head>\n";
  print DETAIL "<title>$config{ServerName} - Soldat Server $lang[0] - $player</title>\n";
  print DETAIL "</head>\n";
  print DETAIL "<body bgcolor=\"$style{BGColor}\" text=\"$style{TextColor}\" link=\"$style{LinkColor}\">\n";
  print DETAIL "<center>\n";
  print DETAIL "<font face=\"$style{FontFace}\" size=\"5\"><b><u>$config{ServerName}</u></b></font><br>\n";
  print DETAIL "<font face=\"$style{FontFace}\" size=\"2\"><b><a href=\"..\">$lang[26]</a></b></font><br><br>\n";
  print DETAIL "<font face=\"$style{FontFace}\" size=\"3\"><b>$lang[14]: $player</b></font><br><br>\n";

  ## GENERAL INFO ###
  print DETAIL "<table width=\"90%\" border=\"$style{TableBorder}\" cellspacing=\"1\">\n";
  print DETAIL "<tr><td bgcolor=\"$style{TableTopicColor}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[27]</b></font></td></tr>\n";
  print DETAIL "</table>\n";
  print DETAIL "<table width=\80%\" border=\"$style{TableBorder}\" cellspacing=\"0\">\n";
  print DETAIL "<tr>\n";
  print DETAIL "<td width=\"50%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[30]</b></font></td>\n";
  print DETAIL "<td width=\"50%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>" . $players->{$player}->{rank} . "</b></font></td>\n";
  print DETAIL "</tr>\n";
  print DETAIL "<tr>\n";
  print DETAIL "<td width=\"50%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[29]</b></font></td>\n";
  print DETAIL "<td width=\"50%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>" . $players->{$player}->{skill} . "</b></font></td>\n";
  print DETAIL "</tr>\n";
  print DETAIL "<tr>\n";
  print DETAIL "<td width=\"50%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[8]</b></font></td>\n";
  print DETAIL "<td width=\"50%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>" . $players->{$player}->{kills} . "</b></font></td>\n";
  print DETAIL "</tr>\n";
  print DETAIL "<tr>\n";
  print DETAIL "<td width=\"50%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[28]</b></font></td>\n";
  print DETAIL "<td width=\"50%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>" . $players->{$player}->{deaths} . "</b></font></td>\n";
  print DETAIL "</tr>\n";
  print DETAIL "<tr>\n";
  print DETAIL "<td width=\"50%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[16]</b></font></td>\n";
  print DETAIL "<td width=\"50%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$players->{$player}->{killdeath}</b></font></td>\n";
  print DETAIL "</tr>\n";
  print DETAIL "<tr>\n";
  print DETAIL "<td width=\"50%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[9]</b></font></td>\n";
  print DETAIL "<td width=\"50%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>" . $players->{$player}->{suicides} . "</b></font></td>\n";
  print DETAIL "</tr>\n";
  print DETAIL "<tr>\n";
  print DETAIL "<td width=\"50%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[32]</b></font></td>\n";
  print DETAIL "<td width=\"50%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>" . $players->{$player}->{captures} . "</b></font></td>\n";
  print DETAIL "</tr>\n";
  print DETAIL "<tr>\n";
  print DETAIL "<td width=\"50%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[33]</b></font></td>\n";
  print DETAIL "<td width=\"50%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>" . $players->{$player}->{returnes} . "</b></font></td>\n";
  print DETAIL "</tr>\n";
  print DETAIL "<tr>\n";
  print DETAIL "<td width=\"50%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[38]</b></font></td>\n";
  print DETAIL "<td width=\"50%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>" . ($#{$players->{$player}->{chat}}+1) . "</b></font></td>\n";
  print DETAIL "</tr>\n";
  print DETAIL "</table>\n";
  print DETAIL "<br><br>\n";

  ### USED WEAPONS ###
  print DETAIL "<table width=\"90%\" border=\"$style{TableBorder}\" cellspacing=\"0\">\n";
  print DETAIL "<tr><td bgcolor=\"$style{TableTopicColor}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[20]</b></font></td></tr>\n";
  print DETAIL "</table>\n";
  print DETAIL "<table width=\80%\" border=\"$style{TableBorder}\" cellspacing=\"1\">\n";
  print DETAIL "<tr>\n";
  print DETAIL "<td width=\"50%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[21]</b></font></td>\n";
  print DETAIL "<td width=\"25%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[15]</b></font></td>\n";
  print DETAIL "<td width=\"25%\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[19]</b></font></td>\n";
  print DETAIL "</tr>\n";
  foreach $weapon (keys %{$players->{$player}->{deathweapon}}) { 
   if (!defined $players->{$player}->{killweapon}->{$weapon}) { $players->{$player}->{killweapon}->{$weapon} = 0; }
  }
  foreach $weapon (sort {$players->{$player}->{killweapon}->{$b} <=> $players->{$player}->{killweapon}->{$a}} keys %{$players->{$player}->{killweapon}}) {
    if (!defined $players->{$player}->{deathweapon}->{$weapon}) { $players->{$player}->{deathweapon}->{$weapon} = 0; }
    print DETAIL "<tr>\n";
    print DETAIL "<td width=\"50%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b><a href=\"weapon" . $weapons->{$weapon}->{id} . "\">$weapon</a></b></font></td>\n";
    print DETAIL "<td width=\"25%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>" . $players->{$player}->{killweapon}->{$weapon} . "</b></font></td>\n";
    print DETAIL "<td width=\"25%\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>" . $players->{$player}->{deathweapon}->{$weapon} . "</b></font></td>\n";
    print DETAIL "</tr>\n";
  }
  print DETAIL "</table>\n";
  print DETAIL "<br><br>\n";

  print DETAIL "<font face=\"$style{FontFace}\" size=\"2\"><b><a href=\"..\">$lang[26]</a></b></font><br><br>\n";
  print DETAIL "</center>\n";
  print DETAIL "</body>\n";
  print DETAIL "</html>\n";
  close(DETAIL);
}

### GENERATION TIME ###
print INDEX "$lang[22]: $gentime\n";
print INDEX "</font>\n";
print INDEX "</center>\n";
print INDEX "</body>\n";
print INDEX "</html>\n";

close(INDEX);
